/*
Script: 		comboBoo.js
License:		MIT-style license.
Credits:		Bruno Torrinha - www.torrinha.com
				Dave DJB31st Beaumont - www.djb31st.co.uk (converted to mootools 1.2
				Mootools framework - mootools.net.
*/

var comboBoo = new Class({
	Implements: [Options,Events], 
	options: {
		className: 'comboBoo'
	},

	initialize: function(el, options){
		this.setOptions(options);
		this.oldCombo = $(el);
		this.bOpen = false;
		var pos = el.getCoordinates();

		this.comboLink = new Element('a', {'class': this.options.className + '-label', 'id': el.name}).setStyles({top: pos.top+'px', left: pos.left+'px', width: pos.width+'px'}).inject(document.body).set('html',el.options[el.options.selectedIndex].text);
		this.comboList = new Element('ul', {'class': this.options.className + '-list', 'id': 'choices-' + el.name}).setStyles({display: 'none', top: pos.top+'px', left: pos.left+'px', width: pos.width + 33+'px'}).injectAfter(this.comboLink);
		this.comboLink.setStyle('background-color','#000');
		this.comboList.set('opacity', '0');

		this.addComboLinkEvents(this.comboLink);

		this.build(el);
//		el.setStyle('display', 'none');
		this.comboList.setStyle('display', '');
	},

	build: function(el){
		for(i = 0; i < el.length; i++) {
			var el2 = new Element('li', {'id': i}).set('html',el.options[i].text);
			this.addChoiceEvents(el2).injectInside(this.comboList);
		};
	},

	click: function(el) {
		if (this.bOpen) {
			this.bOpen = false;
			this.comboList.tween('opacity','0');
		}else{
			this.bOpen = true;
			this.comboList.tween('opacity','1');
		}
	},

	comboOver: function() {
		if (!this.bOpen) this.comboLink.tween('background-color','#600');
	},

	comboOut: function(el) {
		if (!this.bOpen) this.comboLink.tween('background-color','#000');
	},

	choiceOver: function(el) {
		if (this.selected) this.selected.removeClass('choice-selected');
		this.selected = el.addClass('choice-selected');
	},

	choiceSelect: function(el) {
		this.bOpen = false;
		this.comboLink.tween('background-color','#000');
		this.comboList.tween('opacity','0');
		this.comboLink.set('html',el.get('text'));
		this.oldCombo.selectedIndex = el.id;
	},

	addComboLinkEvents: function(el) {
		return el.addEvents({
			click: this.click.bind(this, [el]), 
			mouseover: this.comboOver.bind(this, [el]), 
			mouseleave: this.comboOut.bind(this, [el])
		});
	},

	addChoiceEvents: function(el) {
		return el.addEvents({
			mouseover: this.choiceOver.bind(this, [el]),
			mousedown: this.choiceSelect.bind(this, [el])
		});
	}
});

comboBoo.implement(new Events, new Options);